#include <windows.h>
#include <stdio.h>
#include <Dbghelp.h>


int __stdcall MyPrintFunc ( HWND hWnd, LPCTSTR lpText, LPCTSTR lpCaption, UINT uType) {

	printf ("------------------------\n");
	printf ("Hello, I'm MyPrintFunc!\n");
	printf ("  %s\n", lpText );
	printf ("  %s\n", lpCaption );
	printf ("------------------------\n");

	return 0;
}


int main(int argc, char* argv[]) {

	DWORD Base = (DWORD) GetModuleHandle ( NULL );
	ULONG cbSize = 0;
	PIMAGE_IMPORT_DESCRIPTOR pImageImportDescriptor = NULL;
	PIMAGE_THUNK_DATA pImageThunkData = NULL;
	PIMAGE_THUNK_DATA pOrgImageThunkData = NULL;
	
	//
	// Print Function Information
	//

	FARPROC pfnMessageBox = GetProcAddress ( GetModuleHandle ("user32.dll"), "MessageBoxA" );

	printf ("MessageBoxA: %p\n", pfnMessageBox );
	printf ("MyPrintFunc: %p\n", MyPrintFunc );
	printf ("\n");
	
	//
	// Print Import Descriptor and IAT
	//
	
	pImageImportDescriptor = (PIMAGE_IMPORT_DESCRIPTOR)
		ImageDirectoryEntryToData ( 
			(HMODULE) Base,
			TRUE,
			IMAGE_DIRECTORY_ENTRY_IMPORT,
			&cbSize);

	if ( !pImageImportDescriptor ) {
		printf ("ImageDirectoryEntryToData failed with %u\n", GetLastError() );
		return FALSE;
	}
			
	for ( ; pImageImportDescriptor->Name; pImageImportDescriptor++ ) {

		// (Base) + (RVA to the module Name)
		char* pModuleName = (char*) ( Base + pImageImportDescriptor->Name );
		DWORD ModuleBase = (DWORD) GetModuleHandle ( pModuleName );

		printf ("%p %s\n", ModuleBase, pModuleName ); 

		// IAT
		pImageThunkData = (PIMAGE_THUNK_DATA) ( Base + pImageImportDescriptor->FirstThunk ) ;

		// Original Thunk Data
		pOrgImageThunkData = (PIMAGE_THUNK_DATA) ( Base + pImageImportDescriptor->OriginalFirstThunk );
		
		for ( ; pImageThunkData->u1.Function; pImageThunkData++, pOrgImageThunkData++ ) {

			//
			// Actual Address to the imported function
			//
			
			FARPROC pfnImportedFunc = (FARPROC) ( pImageThunkData->u1.Function);
			printf ("  %p ", pfnImportedFunc );

			//
			// Dump Original Thunk
			//

			if ( 0x80000000 & (DWORD) pOrgImageThunkData ) {
				DWORD dwOrdinal = (0x7fffffff) & (DWORD) pOrgImageThunkData;
				printf ("%u\n", dwOrdinal );
			}
			else {
				PIMAGE_IMPORT_BY_NAME pImageImportByName = (PIMAGE_IMPORT_BY_NAME) ( Base + pOrgImageThunkData->u1.AddressOfData);
				printf ( "%-28s (%x)\n", &pImageImportByName->Name, pImageImportByName->Hint ); 
			}
			
#if 1
			//
			// Change an imported address address for MessageBoxA to the one of MyPrintFunc. 
			//

			if ( pfnImportedFunc == pfnMessageBox ) {
				
				DWORD flOldProtect;
				PVOID pfnNewFunc = MyPrintFunc;

				// By default, IAT is in READONLY page.  
				VirtualProtect ( pImageThunkData, sizeof(DWORD), PAGE_READWRITE, &flOldProtect );
				WriteProcessMemory ( GetCurrentProcess(), pImageThunkData, &pfnNewFunc, sizeof (DWORD), NULL);
				
			}
#endif		
		}
		
	}

	::MessageBoxA ( NULL, "Hello", "Message", MB_OK );
	
	return TRUE;
}
